command_debug.sh 3.7 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124
  1. #!/bin/bash
  2. # LinuxGSM command_debug.sh function
  3. # Author: Daniel Gibbs
  4. # Website: https://linuxgsm.com
  5. # Description: Runs the server without tmux and directly from the terminal.
  6. commandname="DEBUG"
  7. commandaction="Debuging"
  8. functionselfname="$(basename "$(readlink -f "${BASH_SOURCE[0]}")")"
  9. fn_firstcommand_set
  10. # Trap to remove lockfile on quit.
  11. fn_lockfile_trap(){
  12. # Remove lockfile.
  13. rm -f "${lockdir:?}/${selfname}.lock"
  14. # resets terminal. Servers can sometimes mess up the terminal on exit.
  15. reset
  16. fn_print_dots "Stopping debug"
  17. fn_print_ok_nl "Stopping debug"
  18. fn_script_log_pass "Stopping debug"
  19. # remove trap.
  20. trap - INT
  21. core_exit.sh
  22. }
  23. check.sh
  24. fix.sh
  25. info_distro.sh
  26. info_config.sh
  27. # NOTE: Check if works with server without parms. Could be intergrated in to info_parms.sh.
  28. fn_parms
  29. fn_print_header
  30. {
  31. echo -e "${lightblue}Distro:\t\t${default}${distroname}"
  32. echo -e "${lightblue}Arch:\t\t${default}${arch}"
  33. echo -e "${lightblue}Kernel:\t\t${default}${kernel}"
  34. echo -e "${lightblue}Hostname:\t\t${default}${HOSTNAME}"
  35. echo -e "${lightblue}tmux:\t\t${default}${tmuxv}"
  36. echo -e "${lightblue}Avg Load:\t\t${default}${load}"
  37. echo -e "${lightblue}Free Memory:\t\t${default}${physmemfree}"
  38. echo -e "${lightblue}Free Disk:\t\t${default}${availspace}"
  39. } | column -s $'\t' -t
  40. # glibc required.
  41. if [ "${glibc}" ]; then
  42. if [ "${glibc}" == "null" ]; then
  43. # Glibc is not required.
  44. :
  45. elif [ -z "${glibc}" ]; then
  46. echo -e "${lightblue}glibc required:\t${red}UNKNOWN${default}"
  47. elif [ "$(printf '%s\n'${glibc}'\n' ${glibcversion} | sort -V | head -n 1)" != "${glibc}" ]; then
  48. echo -e "${lightblue}glibc required:\t${red}${glibc} ${default}(${red}distro glibc ${glibcversion} too old${default})"
  49. else
  50. echo -e "${lightblue}glibc required:\t${green}${glibc}${default}"
  51. fi
  52. fi
  53. # Server IP
  54. echo -e "${lightblue}Game Server IP:\t${default}${ip}:${port}"
  55. # External server IP.
  56. if [ "${extip}" ]; then
  57. if [ "${ip}" != "${extip}" ]; then
  58. echo -e "${lightblue}Internet IP:\t${default}${extip}:${port}"
  59. fi
  60. fi
  61. # Server password.
  62. if [ "${serverpassword}" ]; then
  63. echo -e "${lightblue}Server password:\t${default}${serverpassword}"
  64. fi
  65. echo -e "${lightblue}Start parameters:${default}"
  66. if [ "${engine}" == "source" ]||[ "${engine}" == "goldsrc" ]; then
  67. echo -e "${executable} ${parms} -debug"
  68. else
  69. echo -e "${executable} ${parms}"
  70. fi
  71. echo -e ""
  72. echo -e "Use for identifying server issues only!"
  73. echo -e "Press CTRL+c to drop out of debug mode."
  74. fn_print_warning_nl "If ${selfname} is already running it will be stopped."
  75. echo -e ""
  76. if ! fn_prompt_yn "Continue?" Y; then
  77. exitcode=0
  78. core_exit.sh
  79. fi
  80. fn_print_info_nl "Stopping any running servers"
  81. fn_script_log_info "Stopping any running servers"
  82. exitbypass=1
  83. command_stop.sh
  84. fn_firstcommand_reset
  85. unset exitbypass
  86. fn_print_dots "Starting debug"
  87. fn_script_log_info "Starting debug"
  88. fn_print_ok_nl "Starting debug"
  89. # Create lockfile.
  90. date '+%s' > "${lockdir}/${selfname}.lock"
  91. echo "${version}" >> "${lockdir}/${selfname}.lock"
  92. echo "${port}" >> "${lockdir}/${selfname}.lock"
  93. fn_script_log_info "Lockfile generated"
  94. fn_script_log_info "${lockdir}/${selfname}.lock"
  95. cd "${executabledir}" || exit
  96. # Note: do not add double quotes to ${executable} ${parms}.
  97. if [ "${engine}" == "source" ]||[ "${engine}" == "goldsrc" ]; then
  98. ${executable} ${parms} -debug
  99. elif [ "${shortname}" == "arma3" ]; then
  100. # Arma3 requires semicolons in the module list, which need to
  101. # be escaped for regular (tmux) loading, but need to be
  102. # stripped when loading straight from the console.
  103. ${executable} ${parms//\\;/;}
  104. elif [ "${engine}" == "quake" ]; then
  105. ${executable} ${parms} -condebug
  106. else
  107. ${executable} ${parms}
  108. fi
  109. fn_lockfile_trap
  110. fn_print_dots "Stopping debug"
  111. fn_print_ok_nl "Stopping debug"
  112. fn_script_log_info "Stopping debug"
  113. core_exit.sh